package net.wanji.opt.servicev2.judgeanalysis;

import com.baomidou.mybatisplus.extension.service.IService;
import net.wanji.opt.entity.judgeanalysis.AnalysisProblemCrossDay;
import net.wanji.opt.vo2.CrossOptAnalysisVO;

import java.text.ParseException;
import java.util.List;
import java.util.Map;

/**
* <p>
* 路口问题分析 服务类
* </p>
*
* @author fengyi
* @since 2025-03-13
*/
public interface AnalysisProblemCrossDayService extends IService<AnalysisProblemCrossDay> {

    /**
    * 路口问题分析详情
    * @param id
    * @return
    */
    AnalysisProblemCrossDay info(Long id);

    /**
    * 路口问题分析新增
    * @param param 根据需要进行传值
    * @return
    */
    void add(AnalysisProblemCrossDay param);

    /**
    * 路口问题分析修改
    * @param param 根据需要进行传值
    * @return
    */
    void modify(AnalysisProblemCrossDay param);

    /**
    * 路口问题分析删除(单个条目)
    * @param id
    * @return
    */
    void remove(Long id);

    /**
    * 删除(多个条目)
    * @param ids
    * @return
    */
    void removes(List<Long> ids);

    /**
     * 更新路口区域id
     * @return
     */
    void updateCrossAreaIdByCondition();


    List<AnalysisProblemCrossDay> getListSingleByStartAndEnd(String crossId,Integer startTime, Integer endTime);

    List<AnalysisProblemCrossDay> selectCountByType(Map<String, Object> map);


    Map<String, Object> selectSingerByProblemTrend(String crossId, Integer startTime, Integer endTime) throws ParseException;

    /**
     * 路口优化信息
     *
     * @param crossID 路口ID
     * @param date    日期
     */
    CrossOptAnalysisVO getCrossOptAnalysis(String crossID, String startTime,String endTime);
}
