package net.wanji.opt.servicev2.judgeanalysis.impl;

import com.alibaba.fastjson.JSONObject;
import net.wanji.common.utils.tool.DateUtil;
import net.wanji.opt.common.EsDateIndexUtil;
import net.wanji.opt.common.enums.CrossDirEnum;
import net.wanji.opt.entity.judgeanalysis.AnalysisProblemCrossDay;
import net.wanji.opt.entity.judgeanalysis.AnalysisProblemCrossDirHour;
import net.wanji.opt.dao.mapper.judgeanalysis.AnalysisProblemCrossDirHourMapper;
import net.wanji.opt.servicev2.judgeanalysis.AnalysisProblemCrossDirHourService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;
import javax.annotation.Resource;
import java.text.ParseException;
import java.time.LocalTime;
import java.time.format.DateTimeFormatter;
import java.util.*;
import java.util.stream.Collectors;

/**
* <p>
* 路口方向按小时粒度问题分析 服务实现类
* </p>
*
* @author fengyi
* @since 2025-03-20
*/
@Service
 public class AnalysisProblemCrossDirHourServiceImpl extends ServiceImpl<AnalysisProblemCrossDirHourMapper, AnalysisProblemCrossDirHour> implements AnalysisProblemCrossDirHourService {

	 @Resource
	 private AnalysisProblemCrossDirHourMapper analysisProblemCrossDirHourMapper;

	
	 /**
	 * 路口方向按小时粒度问题分析详情
	 * @param id
	 * @return
	 */
	 @Override
	 public AnalysisProblemCrossDirHour info(Long id) {
	
	 	return getById(id);
	 }
	
	 /**
	 * 路口方向按小时粒度问题分析新增
	 * @param param 根据需要进行传值
	 * @return
	 */
	 @Override
	 public void add(AnalysisProblemCrossDirHour param) {
	
	 	save(param);
	 }
	
	 /**
	 * 路口方向按小时粒度问题分析修改
	 * @param param 根据需要进行传值
	 * @return
	 */
	 @Override
	 public void modify(AnalysisProblemCrossDirHour param) {
	
	 	updateById(param);
	 }
	
	 /**
	 * 路口方向按小时粒度问题分析删除(单个条目)
	 * @param id
	 * @return
	 */
	 @Override
	 public void remove(Long id) {
	 	removeById(id);
	 }
	
	 /**
	 * 路口方向按小时粒度问题分析删除(多个条目)
	 * @param ids
	 * @return
	 */
	 @Override
	 public void removes(List<Long> ids) {
	
	 	removeByIds(ids);
	 }
	Map<String,Object>getParamMap(String crossId,String eventType,Integer startTime, Integer endTime){
		Map<String,Object> map=new  HashMap();
		map.put("crossId",crossId);
		map.put("eventType",eventType);
		map.put("startTime",startTime);
		map.put("endTime",endTime);
		return map;
	}
	@Override
	public Map<String, Object> directionByProblemTrend(String crossId, String eventType, Integer startTime, Integer endTime) throws ParseException {
		List<AnalysisProblemCrossDirHour>list=analysisProblemCrossDirHourMapper.selectSingerByProblemTrend(getParamMap(crossId,eventType,startTime,endTime));
		Date sd= DateUtil.parse(startTime.toString(), EsDateIndexUtil.YMD_FORMATTER);
		Date ed =DateUtil.parse(endTime.toString(),EsDateIndexUtil.YMD_FORMATTER);
		//存放期间全部时段
		Set<String> sortedSet = EsDateIndexUtil.getTimeGranularityAxis("4", DateUtil.formatDate(sd,EsDateIndexUtil.YMD_HM_FORMATTER), DateUtil.formatDate(ed,EsDateIndexUtil.YMD_HM_FORMATTER));
		List<Map<String ,Object>>allList=new ArrayList<>();

		Map<Integer, List<AnalysisProblemCrossDirHour>> groupByType = list.stream().collect(Collectors.groupingBy(o ->o.getDir(), TreeMap::new, Collectors.toList()));

		for(Map.Entry<Integer,List<AnalysisProblemCrossDirHour>>entry:groupByType.entrySet()){
			Integer key = entry.getKey();
		 	//同一方向每个日期问题数量
			List<AnalysisProblemCrossDirHour> value = entry.getValue();

			String typeName = value.get(0).getTypeName();
			Integer dir = value.get(0).getDir();
			//有实际数据的时刻点
			Set<String> timeList = value.stream().map(po -> po.getDt().toString()).collect(Collectors.toSet());
			//补充缺少时段数据，保留时段字段默认值
			for (String timesing: sortedSet){
				if(!timeList.contains(timesing)){
					AnalysisProblemCrossDirHour analysisProblemCrossDirHour = new AnalysisProblemCrossDirHour();
					analysisProblemCrossDirHour.setDt(Integer.valueOf(timesing));
					analysisProblemCrossDirHour.setEventNumber(0);
					value.add(analysisProblemCrossDirHour);
				}
			}
			value.stream().sorted(Comparator.comparing(AnalysisProblemCrossDirHour::getDt)).collect(Collectors.toList());
			List<Integer> numberlist = value.stream().map(AnalysisProblemCrossDirHour::getEventNumber).collect(Collectors.toList());
			Map<String,Object>maplist=new HashMap<>();
			maplist.put("eventType",key);
			maplist.put("eventLabel",typeName);
			maplist.put("dir",dir);
			maplist.put("dirName", CrossDirEnum.getDesc(dir));
			maplist.put("list",numberlist);
			allList.add(maplist);
		}

		JSONObject jsonObject = new JSONObject();
		jsonObject.put("dataList", allList);
		jsonObject.put("timeList",sortedSet);
		return jsonObject;
	}
	Map<String,Object>getHappyParamMap(String crossId,String eventType,Integer startTime, Integer endTime){
		Map<String,Object> map=new  HashMap();
		map.put("crossId",crossId);
        map.put("eventType",eventType);
		map.put("startTime",startTime);
		map.put("endTime",endTime);
		return map;
	}
	@Override
	public Map<String, Object> crossingHappyByProblemTrend(String crossId, String eventType,Integer startTime, Integer endTime) throws Exception {
		//按照小时
		List<AnalysisProblemCrossDirHour> listHourSql =analysisProblemCrossDirHourMapper.selectHappyByProblemTrend(getHappyParamMap(crossId,eventType,startTime,endTime));

		//按照方向
		List<AnalysisProblemCrossDirHour> happyDriectList=analysisProblemCrossDirHourMapper.selectDirectByProblemTrend(getHappyParamMap(crossId,eventType,startTime,endTime));

		//所有时间段
		Set<String> allHourset=new LinkedHashSet();
		//所有方向
		List<Map<String ,Object>> allHappyList=new ArrayList<>();
		// 定义时间格式
		DateTimeFormatter formatter = DateTimeFormatter.ofPattern("HH:mm");
		//取出时间
       for (AnalysisProblemCrossDirHour list: listHourSql) {

		      String stringHour = list.getHours_window_start_time();
             if(stringHour!=null ) {
				// 解析时间字符串为LocalTime对象
				LocalTime startTimeHour = LocalTime.parse(stringHour, formatter);

				// 对时间加一个小时得到结束时间
				LocalTime endTimeHour = startTimeHour.plusHours(1);

				// 格式化开始时间和结束时间为所需的字符串格式
				String formattedTimeRange = startTimeHour.format(formatter) + " - " + endTimeHour.format(formatter);
				allHourset.add(formattedTimeRange);
			}
	   }

		//取出方向
		for (AnalysisProblemCrossDirHour dirlist: happyDriectList) {

			  Integer dirCode = dirlist.getDir();
			 Map<String,Object>maplist=new HashMap<>();
			  maplist.put("dir",dirCode);
			  maplist.put("dirName", CrossDirEnum.getDesc(dirCode));
			 allHappyList.add(maplist);
		}


		JSONObject jsonObject = new JSONObject();
		jsonObject.put("dirList", allHappyList);
		jsonObject.put("timeList",allHourset);
		return jsonObject;
	}
}
